<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<link rel="stylesheet" href="style.css" type="text/css">
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type">
<meta name="viewport" content="width=device-width, initial-scale=1">
<link rel="Start" href="index.html">
<link rel="previous" href="RandList.html">
<link rel="Up" href="index.html">
<link title="Index of types" rel=Appendix href="index_types.html">
<link title="Index of values" rel=Appendix href="index_values.html">
<link title="Index of modules" rel=Appendix href="index_modules.html">
<link title="Utils" rel="Chapter" href="Utils.html">
<link title="RandList" rel="Chapter" href="RandList.html">
<link title="Tree" rel="Chapter" href="Tree.html"><title>Tree</title>
</head>
<body>
<div class="navbar"><a class="pre" href="RandList.html" title="RandList">Previous</a>
&nbsp;<a class="up" href="index.html" title="Index">Up</a>
&nbsp;</div>
<h1>Module <a href="type_Tree.html">Tree</a></h1>

<pre><span id="MODULETree"><span class="keyword">module</span> Tree</span>: <code class="code">sig</code> <a href="Tree.html">..</a> <code class="code">end</code></pre><div class="info module top">
<div class="info-desc">
<p>Utilitary methods to work on trees.</p>
</div>
</div>
<hr width="100%">

<pre><code><span id="TYPEtree"><span class="keyword">type</span> <code class="type"></code>tree</span> = </code></pre><table class="typetable">
<tr>
<td align="left" valign="top" >
<code><span class="keyword">|</span></code></td>
<td align="left" valign="top" >
<code><span id="TYPEELTtree.Leaf"><span class="constructor">Leaf</span></span></code></td>

</tr>
<tr>
<td align="left" valign="top" >
<code><span class="keyword">|</span></code></td>
<td align="left" valign="top" >
<code><span id="TYPEELTtree.Node"><span class="constructor">Node</span></span> <span class="keyword">of</span> <code class="type">int * <a href="Tree.html#TYPEtree">tree</a> * <a href="Tree.html#TYPEtree">tree</a> * int * bool</code></code></td>
<td class="typefieldcomment" align="left" valign="top" ><code>(*</code></td><td class="typefieldcomment" align="left" valign="top" ><div class="info ">
<div class="info-desc">
<p>Node: label, left, right, size, lock</p>
</div>
</div>
</td><td class="typefieldcomment" align="left" valign="bottom" ><code>*)</code></td>
</tr>
<tr>
<td align="left" valign="top" >
<code><span class="keyword">|</span></code></td>
<td align="left" valign="top" >
<code><span id="TYPEELTtree.CNode"><span class="constructor">CNode</span></span> <span class="keyword">of</span> <code class="type">int list * <a href="Tree.html#TYPEtree">tree</a></code></code></td>
<td class="typefieldcomment" align="left" valign="top" ><code>(*</code></td><td class="typefieldcomment" align="left" valign="top" ><div class="info ">
<div class="info-desc">
<p>CNode: elements in prefix order, tree of matching structure</p>
</div>
</div>
</td><td class="typefieldcomment" align="left" valign="bottom" ><code>*)</code></td>
</tr></table>

<div class="info ">
<div class="info-desc">
<p>A tree, which can be either a leaf, a node or a compressed node</p>
</div>
</div>


<pre><span id="VALmake_tree"><span class="keyword">val</span> make_tree</span> : <code class="type">int -> <a href="Tree.html#TYPEtree">tree</a></code></pre><div class="info ">
<div class="info-desc">
<p>Makes a new node with leaves as left and right subtrees.</p>
</div>
</div>

<pre><span id="VALget_size"><span class="keyword">val</span> get_size</span> : <code class="type"><a href="Tree.html#TYPEtree">tree</a> -> int</code></pre><div class="info ">
<div class="info-desc">
<p>Returns a tree's size.</p>
</div>
</div>

<pre><span id="VALget_label"><span class="keyword">val</span> get_label</span> : <code class="type"><a href="Tree.html#TYPEtree">tree</a> -> int option</code></pre><div class="info ">
<div class="info-desc">
<p>Returns a tree's label if the tree is a node, None otherwise.</p>
</div>
</div>

<pre><span id="VALinsert"><span class="keyword">val</span> insert</span> : <code class="type">int -> <a href="Tree.html#TYPEtree">tree</a> -> <a href="Tree.html#TYPEtree">tree</a></code></pre><div class="info ">
<div class="info-desc">
<p>Inserts an element in the tree.</p>
</div>
<ul class="info-attributes">
<li><b>Returns</b> the tree with the element added (or unchanged if the element was already in)</li>
</ul>
</div>

<pre><span id="VALtree_from_list"><span class="keyword">val</span> tree_from_list</span> : <code class="type">int list -> <a href="Tree.html#TYPEtree">tree</a></code></pre><div class="info ">
<div class="info-desc">
<p>Makes a tree containing the elements of a list, inserted in order.</p>
</div>
<ul class="info-attributes">
<li><b>Returns</b> the root of the new tree, with the first element of the list as label</li>
</ul>
</div>

<pre><span id="VALsignature"><span class="keyword">val</span> signature</span> : <code class="type"><a href="Tree.html#TYPEtree">tree</a> -> string</code></pre><div class="info ">
<div class="info-desc">
<p>Returns the tree's signature, which represents its structure.
  With l as the left subtree and r as the right one, the signature is :</p>
<ul>
<li>empty if the tree is a leaf</li>
<li>("(" signature l ")" signature r) otherwise</li>
</ul>
</div>
<ul class="info-attributes">
<li><b>Returns</b> a string containing the tree's signature</li>
</ul>
</div>

<pre><span id="VALprefix"><span class="keyword">val</span> prefix</span> : <code class="type"><a href="Tree.html#TYPEtree">tree</a> -> int list</code></pre><div class="info ">
<div class="info-desc">
<p>Returns the elements of the tree in prefix order.</p>
</div>
<ul class="info-attributes">
<li><b>Returns</b> a list of the tree's elements.</li>
</ul>
</div>

<pre><span id="VALcompress"><span class="keyword">val</span> compress</span> : <code class="type"><a href="Tree.html#TYPEtree">tree</a> -> <a href="Tree.html#TYPEtree">tree</a></code></pre><div class="info ">
<div class="info-desc">
<p>Compresses the tree by comparing subtrees structure.</p>
</div>
<ul class="info-attributes">
<li><b>Returns</b> a compressed tree</li>
</ul>
</div>

<pre><span id="VALsearch"><span class="keyword">val</span> search</span> : <code class="type">int -> <a href="Tree.html#TYPEtree">tree</a> -> bool</code></pre><div class="info ">
<div class="info-desc">
<p>Looks for an element in the tree.</p>
</div>
<ul class="info-attributes">
<li><b>Returns</b> true if the element is in the tree, false otherwise</li>
</ul>
</div>
</body></html>
